unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uZeit, StdCtrls, ExtCtrls, UTurtle;

type
  TPunkt = class(TObject)
    private
      Farbe :TColor;
      x     :integer;
      y     :integer;
      vx    :real;
      vy    :real;

    public
      constructor create;
      function Getx: Integer;
      procedure Setx(x1 :Integer);
      function Gety: Integer;
      procedure Sety(y1 :Integer);
      procedure SetPosition(x1,y1 :Integer);
      procedure Setfarbe(Color :TColor);
      function Getfarbe: TColor;
      procedure Setvx(vx1 : real );
      Function  Getvx: real;
      procedure Setvy(Vy1 : real );
      Function  Getvy: real;

  end;



  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Turtle1: TTurtle;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button4: TButton;
    Timer1: TTimer;
    Edit4: TEdit;
    Edit5: TEdit;
    Button5: TButton;
    Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Edit6: TEdit;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure zeigen;
    function  Kugelkollision: boolean;
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
  private
    Punkt: TPunkt;
    Punkt2: TPunkt;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  vx2 :real;
  vy2 :real;
  vx22 :real;
  vy22 :real;
  vz   :real;

implementation

{$R *.dfm}

constructor TPunkt.create;
begin
  inherited Create;
end;

function TPunkt.Getx: Integer;
begin
  result:= x;
end;

procedure TPunkt.Setx(x1 :Integer);
begin
  if (x1>= 0) and (x1< 801) then
  begin
    x:= x1;
  end;
end;

function TPunkt.Gety: Integer;
begin
  result:= y;
end;

procedure TPunkt.Sety(y1 :Integer);
begin
  if (y1>= 0) and (y1< 434) then
  begin
    y:= y1;
  end;
end;

function TPunkt.Getfarbe: TColor;
begin
  result:= Farbe;
end;

procedure TPunkt.Setfarbe(Color :TColor);
begin
    Farbe:= Color;
end;

procedure TPunkt.SetPosition(x1,y1 :Integer);
begin
  setx(x1);
  sety(y1);
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
  Punkt := TPunkt.create;
  Punkt2 := TPunkt.create;
  timer1.Interval:= 20;

end;


procedure TForm1.Button4Click(Sender: TObject);
begin
  button3.Click;
  button1.click;
  button2.Click;
  button5.click;
  button6.click;
  button7.Click;
  button8.Click;
  button9.Click;
  button10.click;

  timer1.Enabled:= true;
  vx2:= (Punkt.Getvx)/50;
  vy2:= (Punkt.Getvy)/50;
  vx22:= (Punkt2.Getvx)/50;
  vy22:= (Punkt2.Getvy)/50;
end;

procedure TPunkt.Setvx(vx1 : real );
begin
  vx:= vx1;
end;

Function  TPunkt.Getvx: real;
begin
  Getvx:= vx;
end;

procedure TPunkt.Setvy(Vy1 : real );
begin
  vy:= vy1;
end;

Function  TPunkt.Getvy: real;
begin
  Getvy:= vy;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Punkt.Setfarbe(stringtocolor(edit1.Text));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  punkt.setx(strtoint(edit2.text));
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  punkt.Sety(strtoint(edit3.text));
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  punkt.setvx(strtofloat(edit4.text));
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  punkt.Setvy(strtoint(edit5.text));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (Punkt.Getx+vx2 < 0) or (Punkt.Getx+vx2 > 790) THEN
    vx2 := -vx2;
  Punkt.Setx(round(Punkt.Getx+vx2));
  if (Punkt.Gety+vy2 < 0) or (Punkt.Gety+vy2 > 423) THEN
    vy2 := -vy2;
  Punkt.Sety(round(Punkt.Gety+vy2));

  if (Punkt2.Getx+vx22 < 0) or (Punkt2.Getx+vx22 > 790) THEN
    vx22 := -vx22;
  Punkt2.Setx(round(Punkt2.Getx+vx22));
  if (Punkt2.Gety+vy22 < 0) or (Punkt2.Gety+vy22 > 423) THEN
    vy22 := -vy22;
  Punkt2.Sety(round(Punkt2.Gety+vy22));
  if Kugelkollision = true then
  begin
    vz   := vx22;
    vx22 := vx2;
    vx2  := vz;
    vz   := vy22;
    vy22 := vy2;
    vy2   := vz;
  end;
  zeigen;
end;

procedure  TForm1.zeigen;
begin
  turtle1.Canvas.Brush.Color:= clgreen;
  turtle1.Clear;
  turtle1.Canvas.Brush.Color:= clwhite;
  turtle1.Canvas.Ellipse(punkt.getx ,punkt.gety, punkt.getx+10, punkt.gety+10);
  turtle1.Canvas.Ellipse(punkt2.getx ,punkt2.gety, punkt2.getx+10, punkt2.Gety+10);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  punkt2.setx(strtoint(edit6.text));
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  punkt2.sety(strtoint(edit7.text));
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  punkt2.setvx(strtoint(edit8.text));
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  punkt2.setvy(strtoint(edit9.text));
end;

function TForm1.Kugelkollision: boolean;
var
  kollision: integer;
begin
  kollision := 0;
  If (punkt2.getx + vx22 >= punkt.getx + vx2) then
  begin
    kollision := kollision + 1;
  end;
  If (punkt2.getx + vx22 <= punkt.getx + 10 + vx2) then
  begin
    kollision := kollision + 1;
  end;
  If(punkt2.GetY + vy22 >= punkt.Gety + vy2) then
  begin
    kollision := kollision + 1;
  end;
  If(punkt2.gety + vy22 <= punkt.gety + vy2 + 10) then
  begin
    kollision := kollision + 1;
  end;
  if kollision = 4 then
  begin
    kugelkollision := true;
  end
  else
  begin
    kugelkollision := false;
  end;
end;

end.
